/* main.cpp
Interface to CallWin32.dll
(C) 2002 Niall Douglas
20th October 2002 (started 8th August 2002)

This file is provided under the GNU General Public Licence.
See the file gpl.txt in the archive for more information.
*/

/*
It is very unlikely you'll ever need to modify this file. It's better to do
init and deinit inside your own init function which RISC-OS calls for you as
there's loads of things you are not allowed to do inside a DllMain().
*/

#include "SignalVector.h"
#include "windows.h"

static void (*CallWinPodule_SignalVectorAddr)(int vector);
static void (*CallWinPodule_GetRISCOSWindowHandlesAddr)(HWND *parent, HWND *riscos);
static void (*CallWinPodule_SetMouseInputDisableAddr)(int yes);
static int  (*CallWinPodule_InstallUpcallAddr)(void (*code)(int op, void *data), void *data);
static HMODULE CallWinPoduleh;
extern HINSTANCE myInstance;
HINSTANCE myInstance;

BOOL APIENTRY DllMain( HINSTANCE hModule, 
                       DWORD  reason, 
                       LPVOID lpReserved)
{
	switch(reason)
	{
		case DLL_PROCESS_ATTACH:
		{
			myInstance=hModule;
			CallWinPoduleh=GetModuleHandle("CallWin32.dll");
			CallWinPodule_SignalVectorAddr=(void (*)(int)) GetProcAddress(CallWinPoduleh, "CallWinPodule_SignalVector");
			if(!CallWinPodule_SignalVectorAddr)
			{
				MessageBox(NULL, "Couldn't find address of CallWinPodule_SignalVector", "Error", MB_OK);
				return false;
			}
			CallWinPodule_GetRISCOSWindowHandlesAddr=(void (*)(HWND *, HWND *)) GetProcAddress(CallWinPoduleh, "CallWinPodule_GetRISCOSWindowHandles");
			if(!CallWinPodule_GetRISCOSWindowHandlesAddr)
			{
				MessageBox(NULL, "Couldn't find address of CallWinPodule_GetRISCOSWindowHandles", "Error", MB_OK);
				return false;
			}
			CallWinPodule_SetMouseInputDisableAddr=(void (*)(int)) GetProcAddress(CallWinPoduleh, "CallWinPodule_SetMouseInputDisable");
			if(!CallWinPodule_SetMouseInputDisableAddr)
			{
				MessageBox(NULL, "Couldn't find address of CallWinPodule_SetMouseInputDisable", "Error", MB_OK);
				return false;
			}
			CallWinPodule_InstallUpcallAddr=(int (*)(void (*)(int, void *data), void *data)) GetProcAddress(CallWinPoduleh, "CallWinPodule_InstallUpcall");
			if(!CallWinPodule_InstallUpcallAddr)
			{
				MessageBox(NULL, "Couldn't find address of CallWinPodule_InstallUpcall", "Error", MB_OK);
				return false;
			}
			return true;
		}
		case DLL_PROCESS_DETACH:
		{
			if(CallWinPoduleh)
			{
				FreeLibrary(CallWinPoduleh);
				CallWinPoduleh=0;
			}
			break;
		}
	}
	return false;
}

void CallWinPodule_SignalVector(int vector)
{
	(CallWinPodule_SignalVectorAddr)(vector);
}

void CallWinPodule_GetRISCOSWindowHandles(void **parent, void **riscos)
{
	(CallWinPodule_GetRISCOSWindowHandlesAddr)((HWND *) parent, (HWND *) riscos);
}

void CallWinPodule_SetMouseInputDisable(int yes)
{
	(CallWinPodule_SetMouseInputDisableAddr)(yes);
}

int CallWinPodule_InstallUpcall(void (*code)(int op, void *data), void *data)
{
	return (CallWinPodule_InstallUpcallAddr)(code, data);
}
